var CustomCheckbox = new Class({
	initialize: function(selectorClass){
		if (selectorClass == "")
			return false;
		this.selectorClass = selectorClass;
		this.checkboxes = $$('.'+this.selectorClass+' input[type="checkbox"]');

		if (this.checkboxes.length > 0)
			this.initEvents();
	},

	initEvents: function(){
		this.checkboxes.each(function(checkbox){
			var container = checkbox.getParent('.'+this.selectorClass);
			var label = $$('label[for="'+checkbox.get('id')+'"]')[0];

			container.addEvent('click', function(e){
				e.stop();
				this.select(container);
			}.bind(this));

			if (label){
				label.addEvent('click', function(e){
					if (e.target.tagName != "A"){
						e.stop();
						this.select(container);
					}
				}.bind(this));
			}
		}.bind(this));

		this.update();
	},

	select: function(container){
		var checkbox = container.getElement('input[type="checkbox"]');

		if (checkbox.checked){
			container.removeClass('checked');
			checkbox.checked = false;
		} else {
			container.addClass('checked');
			checkbox.checked = true;
		}

		this.update();
		checkbox.fireEvent('change');
	},

	update: function(){
		this.checkboxes.each(function(checkbox){
			var container = checkbox.getParent('.checkbox');

			if (checkbox.checked && !container.hasClass('checked'))
				container.addClass('checked');
			else if (!checkbox.checked && container.hasClass('checked'))
				container.removeClass('checked');
		}.bind(this));
	}
});

window.addEvent('domready', function(){
	new CustomCheckbox("checkbox");
});